#info Knot system (DarkBeam formula)

// Based on DarkBeam formula from this thread:
// http://www.fractalforums.com/new-theories-and-research/not-fractal-but-funny-trefoil-knot-routine

#define providesColor
#include "Sky-Pathtracer.frag"


#group Knot
uniform float R1; slider[0.0,1.6,2.3]
uniform float R2; slider[0.0,0.1,2.3]
uniform float R3; slider[0.0,1.6,2.3]
uniform float R5; slider[0.0,1.6,2.3]
uniform float a; slider[0,1,5]
uniform float b; slider[0,1,5]
uniform float polyfoldOrder; slider[0,2,15]
vec2 rotate(vec2 v, float angle) {
	return  vec2(cos(angle)*v.x+sin(angle)*v.y,
		-sin(angle)*v.x+cos(angle)*v.y);
}

vec3 baseColor(vec3 p, vec3 n) {

	return vec3(1.0);
}


float maxDim(vec2 a) { return max(a.x,a.y); }
uniform float RX; slider[0,1,62]
uniform float RZ; slider[0,1,6]
float DE(vec3 p) {
p.xz = rotate(p.xz,RX);
p.yz = rotate(p.yz,RZ);
	float mobius = ((a+b)/polyfoldOrder) * atan(p.y,p.x);
	p.x = length(p.xy)-R1;
	p.xz = rotate(p.xz,mobius);
	
	float m = polyfoldOrder/ (2.*PI);
	float angle = floor(.5+m*(PI/2.-atan(p.x,p.z)))/m;
	p.yz = rotate(p.yz,R5);
	p.xz = rotate(p.xz,angle);
	p.x =p.x -  R3;
	return length(p.xz)-R2;
}

#preset Default
FOV = 0.4
Eye = -0.345332,-6.16714,-4.4525
Target = 0.101118,1.70231,1.70156
Up = -0.52351,0.281361,-0.804222
EquiRectangular = false
FocalPlane = 4.84535
Aperture = 0.04381
Gamma = 2.0354
ToneMapping = 2
Exposure = 1.5465
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2.1053
Detail = -2.84746
DetailAO = -0.20391
FudgeFactor = 0.75
MaxRaySteps = 83
BoundingSphere = 12
Dither = 0.5
NormalBackStep = 1
AO = 0,0,0,0.89535
Specular = 1.5476
SpecularExp = 25
SpotLight = 0.431373,0.537255,1,1
SpotLightPos = 5,-2.2034,0
SpotLightSize = 0.34327
CamLight = 1,1,1,1
CamLightMin = 0
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
Reflection = 0
BaseColor = 1,1,1
OrbitStrength = 1
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.5701
BackgroundColor = 0.6,0.6,0.45
GradientBackground = 0.3
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,0
FloorHeight = 0
FloorColor = 1,1,1
R1 = 2.01036
R2 = 0.28964
R3 = 0.86889
R5 = 0
a = 0
b = 2
polyfoldOrder = 3
#endpreset

